/*	
 *	Version 1.0 du 04/11/1987 : Version de base.
 *              1.0.5 du 10/11/87 (richier) traitement correct options de lpr
 *					    defaut sur -Pps, defaut sur -J
 *		1.1 du 16/11/1987 : Bug si pas d'entete
 *		1.2 du 17/11/1987 : Bug si ^L (showshowpage)
 *		1.2.5 du 18/11/87 (richier): entete "%!  "
 *		1.3 du 19/11/1987 : Prise en compte des LaserWriters
 *		1.4 du 20/11/1987 (richier): erreur sur page pleine, et sur bs
 *		1.5 du 26/11/1987 : Correction sur un fichier non fini par cr.
 *              1.6 du 11/12/1987 (B. Cassagne) : 
 *                    a) modification de l'argument Z : on peut mettre un nombre
 *                       sous la forme ddd.ddd
 *                    b) rajout de l'argument V pour le vertical spacing
 *              1.7 du 16/12/1987 (richier) : suppression d'inconsistences lint
 *		1.8 du 06/05/1988 (paire) : ajout de la structuration ADOBE
 *		1.9 du 10/06/1988 (paire) : tabulation sur le 80eme caractere
 *		1.10 du 02/10/1988 (richier) : 
 *			a) gestion de la taille papier (commande papersize)
 *			b) modification de l'erreur: option ppr inconnue
 *		1.11 du 20/03/1990 (richier) : 	gestion imp: utiliser PRINTER
 *		2.0 du 14/12/1992 (richier) : 
 *			support ascii etendu ISO et Mac, passage a 66x80
 *		2.1 du 04/01/1993 (richier) : 
 *			cadrage: ne pas deborder en haut ou a gauche
 *		2.2 du 20/01/1993 (richier) : 	bug sur header de fichier vide
 *		2.3 du 27/01/1993 (richier) : 	bug sur taille du header
 *		2.4 du 17/03/1993 (richier) : les LWI ne connaissent pas l'ISO
 *		2.5 du 13/12/1993 (richier) : Pb ... si ISO, Pb entete si Mac
 *              2.6 du 15/06/94   (bernardS) : Pb de passage a solaris
 *                      a) utilisation de lp a la place de lpr
 *                      b) acceptation d'argument -d pour lp
 *                      c) modif de LPROPT en LPROPT1 et LPROPT2
 */
#define	PROGNAME	"pprps 2.6"	/* nom du programme */
/*
 *	Ecrit par E. Paire - Bull et Imag
 *	Modifications: E.Paire, B. Cassagne et J.L. Richier, Imag
 *
 * pprps +[78IMBPpLlNnhHDozX<col.>Y<lig.>Z<ps>V<vs>i<prologue>]
 *		<arguments de lpr> [fic1]...
 *
 *	Ce programme permet d'avoir une commande plus standard pour
 *		une imprimante Postscript de maniere a pouvoir utiliser :
 *		- Le format d'impression choisi (optionel)
 *			format portrait	(default) : option 'P' ou 'p'
 *			format paysage            : option 'L' ou 'l'
 *		- le codage ascii 7 bits (7) ou 8 bits ISO (I) ou Mac (M) ou
 *			determine' automatiquement (*, ou defaut)
 *		- la suppression des fichiers binaires (sauf si +B)
 *		- Une numerotation sequentielle par fichier au depart de
 *			chaque ligne (option 'N' ou 'n') ;
 *		- Un header portant le nom absolu du fichier edite (H ou h)
 *			ainsi qu'un numero de page (option 'P'ou 'n');
 *		- Un debug dumpant les actions a venir (option 'D') ;
 *		- La possibilite d'utilser son propre prologue (+ifichier)
 *		- Un formattage de page dependant du nombre de colonnes du
 *			format choisi :  format portrait : option 'p'
 *					 format paysage : option 'l'
 *		- soit une liste de fichier, soit un pipe en entree;
 *		- Toutes les options de la commande 'lpr';
 *		- L'option 'o' permet de diriger la sortie non pas vers "lpr"
 *			mais sur le standard output.
 *		- Le nombre de colonnes desirees est donne par le nombre
 *			immediatement derriere l'option 'X'.
 *			Par defaut : landscape=132, portrait=80.
 *		- Le nombre de lignes desirees est donne par le nombre
 *			immediatement derriere l'option 'Y'.
 *			Par defaut : landscape=55, portrait=66.
 *		- La taille de la police choisie est donnee par le nombre
 *			immediatement derriere l'option 'Z', ou par un
 *			calcul implicite effectue par l'option 'z'.
 *			Par defaut : landscape=9, portrait=10.
 *
 *		L'option -DUSG doit etre mise si on compile sur systeme V
 */

#include	<stdio.h>
#include	<signal.h>
#include	<time.h>
#include	<pwd.h>
#include	<sys/types.h>
#include	<sys/types.h>
#include	<sys/stat.h>
/*   USG pour System V   */
/*   -----------------   */
/* Set your optons here  */
#ifdef	USG
#include <unistd.h>
#include	<sys/pathname.h>
#include	<dirent.h>
#include	<string.h>
#define RINDEX strrchr
#define	LPR	"/usr/bin/lp"
/*#define	LPROPT1	"-T"*/
#define	LPROPT1	"-o1"
/*#define	LPROPT2	"postscript"*/
#define	LPROPT2 "-onb"
/*#define JOB_OPTION "-t"*/
#define JOB_OPTION "-s"
#else	/*USG*/
/*   pas USG donc "a la" Berkeley   */
/*   ----------------------------   */
#include	<sys/param.h>
#include	<strings.h>
#define RINDEX rindex
#define	LPR	"/usr/ucb/lpr"
#define	LPROPT1	"-l"
#define JOB_OPTION "-J"
#endif	/*USG*/

#define TYPE_VIDE	0
#define TYPE_ISO	1
#define TYPE_MAC	2
#define TYPE_BINAIRE	3
#define	DO3POINTS	")sI(\\311)sS("	/* ... en symbol code macvec */

#define	NBLANDSCAPE	 2	/* lignes avant entete en mode paysage */
#define	NBPENTE		10	/* Nombre maximal de ligne d'entete */
#define MAXTRUNC	10	/* longueur max d'un nom non coupe */

/* arguments de formattage de ppr (0 par defaut) */
int	fnumero;	/* numeroter les lignes */
int	fentete;	/* imprimer une entete; 2: longue */
int	flandscape;	/* feuille horizontale (landscape) */
int	ffolding;	/* replier les lignes longues */
int	fdebug;		/* impression des arguments et exit */
int	foutput;	/* envoyer le postcript sur stdout */
int	fpsize;		/* taille police calculee automatiquement */
int	ascii_7;	/* ascii 7 bit seulement */
int	ascii_mac ;	/* ascii 8 bit codage mac */
int	opt_ascii_mac= -1 ;	/* -1 si opt -8, 0 si -I, 1 si -M */
int	binaire_ok ;	/* accepter un fichier suppose non ascii */
char	*prologue ;	/* prologue de remplacement */
char	vertspacing[80];
char	pdate[18] ;		/* date a ecrire sur l'entete */
char	pointsize[80];	/* taille police, si statique */
int	typfont ;		/* 1 : car bold; 2 : souligne */
char	fcn[] = "s" ;	/* fin d'une chaine police normale */
char	*fcs[] = {"sS", "uS"} ;/* fin d'une chaine police symbol */
char	*fcb[] = {"sB", "us"} ;/* fin d'une chaine police bold ou ul */
char	*ap[] = {"ap", "ap", "AP"}; /* car apple 0360 */

int	jobopt = 0 ;		/* il y a une option -J */
char	*jobname = 0;		/* nom du premier fichier */
char	**pa, **ppa ;		/* pointeurs sur les arguments de lpr */
char	**pf, **ppf ;		/* pointeurs sur les fichiers a editer */
char	*nom_fic[NBPENTE] ;	/* pointeur sur le nom du fichier (folding) */
int	nbcpage ;		/* nombre de colonne par ligne */
int	nblpage ;		/* nombre de lignes par page */
int	nopage ;		/* numero de page */
int	topligne ;		/* premier ligne page */
int	docpage ;		/* numero de page dur document */
int	fd_lpr[2] ;		/* pipe utilise pour lpr */
#ifdef USG
#define MAXPATHLEN      1024
#endif
char	nom_dir[MAXPATHLEN+1] ;	/* nom du directory courant */
unsigned char bufin[BUFSIZ+12];	/* pour test bold */
int	nb;			/* pos, nb char dans bufin */
unsigned char	*pos;
#define mypeekc()	(*pos)
FILE	*fin;
char	*nom_abs() ;

char	*msg_warn = "incorrect file name ignored : %s\n" ;
char	*msg_err[] = {
"Use: pprps +[67IMBPpLlNnhHDoX<col>Y<lig>zZ<ps>V<sp>i<prol>] arg_lpr [fic]..",
	"can't get enough memory" ,
	"use `pprps -' for filtering stdin" ,
	"unknown ppr argument: '?'" ,
#define ppr_err msg_err[3][strlen(msg_err[3])-2]
	"can't exec line_printer_command",
	"can't pipe()",
	"can't fork()",
	"cols, lines, pointsize and vertical spacing must be positive",
	} ;

#ifdef USG
char	*getcwd() ;
#define getwd(nom_dir)      getcwd(nom_dir, (size_t) SIZEOFARG-1)
#define GETWD(nom_dir)	 getcwd(nom_dir,MAXPATHLEN+1)
/* unsigned short	getuid();*/
void		free() ;
void		exit() ;
#else
char	*getwd() ;
#define GETWD(nom_dir)	 getwd(nom_dir)
uid_t		getuid();
extern		free() ;
extern		exit() ;
#endif
#ifndef __hpux
long		time() ;
#endif
char		*getlogin();
char		*malloc();
struct passwd	*getpwuid();
char		*getenv();

/*
 * prologue postscript standard
 * la taille de la path est le clippath initial
 */
char * prologue_ps = "\
/bdf{bind def}def /xdf{exch def}bdf\n\
gsave initgraphics clippath pathbbox grestore\n\
	2 index sub/hei xdf 2 index sub/wid xdf/ly xdf/lx xdf\n\
\n\
% pour LW I, definir l'encodage ISO\n\
/ISOLatin1Encoding where{pop}{/ISOLatin1Encoding\n\
StandardEncoding 256 array copy dup 45/minus put dup 144 [\n\
/dotlessi/grave/acute/circumflex/tilde/macron/breve/dotaccent\n\
/dieresis/.notdef/ring/cedilla/.notdef/hungarumlaut/ogonek/caron\n\
/space/exclamdown/cent/sterling/currency/yen/brokenbar/section\n\
/dieresis/copyright/ordfeminine/guillemotleft/logicalnot/hyphen/registered/macron\n\
/degree/plusminus/twosuperior/threesuperior/acute/mu/paragraph/periodcentered\n\
/cedilla/onesuperior/ordmasculine/guillemotright/onequarter/onehalf/threequarters/questiondown\n\
/Agrave/Aacute/Acircumflex/Atilde/Adieresis/Aring/AE/Ccedilla\n\
/Egrave/Eacute/Ecircumflex/Edieresis/Igrave/Iacute/Icircumflex/Idieresis\n\
/Eth/Ntilde/Ograve/Oacute/Ocircumflex/Otilde/Odieresis/multiply\n\
/Oslash/Ugrave/Uacute/Ucircumflex/Udieresis/Yacute/Thorn/germandbls\n\
/agrave/aacute/acircumflex/atilde/adieresis/aring/ae/ccedilla\n\
/egrave/eacute/ecircumflex/edieresis/igrave/iacute/icircumflex/idieresis\n\
/eth/ntilde/ograve/oacute/ocircumflex/otilde/odieresis/divide\n\
/oslash/ugrave/uacute/ucircumflex/udieresis/yacute/thorn/ydieresis\n\
] putinterval def}ifelse\n\
% selon LaserPrep Apple\n\
/macvec 256 array def\n\
/NUL/SOH/STX/ETX/EOT/ENQ/ACK/BEL/BS/HT/LF/VT/FF/CR/SO/SI\n\
/DLE/DC1/DC2/DC3/DC4/NAK/SYN/ETB/CAN/EM/SUB/ESC/FS/GS/RS/US\n\
macvec 0 32 getinterval astore pop\n\
macvec 32/Times-Roman findfont/Encoding get\n\
32 96 getinterval putinterval macvec dup 39/quotesingle put 96/grave put\n\
/Adieresis/Aring/Ccedilla/Eacute/Ntilde/Odieresis/Udieresis/aacute\n\
/agrave/acircumflex/adieresis/atilde/aring/ccedilla/eacute/egrave\n\
/ecircumflex/edieresis/iacute/igrave/icircumflex/idieresis/ntilde/oacute\n\
/ograve/ocircumflex/odieresis/otilde/uacute/ugrave/ucircumflex/udieresis\n\
/dagger/degree/cent/sterling/section/bullet/paragraph/germandbls\n\
/registered/copyright/trademark/acute/dieresis/notequal/AE/Oslash\n\
/infinity/plusminus/lessequal/greaterequal/yen/mu/partialdiff/summation\n\
/product/pi/integral/ordfeminine/ordmasculine/Omega/ae/oslash\n\
/questiondown/exclamdown/logicalnot/radical/florin/approxequal/Delta/guillemotleft\n\
/guillemotright/ellipsis/blank/Agrave/Atilde/Otilde/OE/oe\n\
/endash/emdash/quotedblleft/quotedblright/quoteleft/quoteright/divide/lozenge\n\
/ydieresis/Ydieresis/fraction/currency/guilsinglleft/guilsinglright/fi/fl\n\
/daggerdbl/periodcentered/quotesinglbase/quotedblbase/perthousand/Acircumflex/Ecircumflex/Aacute\n\
/Edieresis/Egrave/Iacute/Icircumflex/Idieresis/Igrave/Oacute/Ocircumflex\n\
/apple/Ograve/Uacute/Ucircumflex/Ugrave/dotlessi/circumflex/tilde\n\
/macron/breve/dotaccent/ring/cedilla/hungarumlaut/ogonek/caron\n\
macvec 128 128 getinterval astore pop\n\
/cft{findfont dup length 1 add dict begin\n\
	{1 index/FID ne{def}{pop pop}ifelse}forall\n\
	currentdict end}bdf\n\
/xft{dup 3 1 roll /Encoding 3 2 roll put definefont pop}bdf\n\
/eft{cft xft}bdf\n\
/sft{cft dup begin /StrokeWidth 50 def\n\
	dup /UniqueID known{/UniqueID UniqueID 16#A000 xor def}if end xft}bdf\n\
/ListISO ISOLatin1Encoding /Courier sft\n\
/ListISO-Bold ISOLatin1Encoding /Courier-Bold eft\n\
/ListMAC macvec /Courier sft /ListMAC-Bold macvec /Courier-Bold eft\n\
/SymbMAC macvec /Symbol eft\n\
\n\
/scal{sca /fM /ListMAC findfont 2 index scalefont def\n\
	/fS /SymbMAC findfont 2 index scalefont def\n\
	/fMB /ListMAC-Bold findfont 2 index scalefont def\n\
	/fIB /ListISO-Bold findfont 2 index scalefont def\n\
	/fI /ListISO findfont 2 index scalefont def\n\
	FI( )stringwidth pop/lwid xdf vsp mul/lhei xdf}bdf\n\
/FI{/fB fIB def fI setfont}bdf /FM{/fB fMB def fM setfont}bdf\n\
/bl{lhei mul neg Y0 add X0 exch moveto}bdf\n\
/S{lwid mul 0 rmoveto}bdf /ta{lwid neg 0 rmoveto}bdf\n\
/s{show}bdf /ss{currentfont exch setfont exch show setfont}bdf\n\
/U{currentpoint 3 index length{(_)show}repeat moveto cvx exec}bdf\n\
/ap{currentfont currentpoint fS setfont(\\360)show moveto setfont( )show}bdf\n\
/sS{fS ss}bdf /sB{fB ss}bdf /uS{/sS U}bdf /us{/s U}bdf /sI{fI ss}bdf\n\
/AP{ap ta (_)show}bdf\n\
/BP{landscape{90 rotate 0 hei neg translate}if}bdf /EP{showpage}bdf\n\
/DS{wid col 2 add lwid mul div hei row 2 add lhei mul div\n\
	dup 2 index lt {true}if pop sca mul/sca xdf scal}bdf\n\
/ST{wid lwid col mul sub dup 0 lt{pop 0}if 2 div lx add/X0 xdf hei lhei row\n\
mul sub dup 0 lt{pop 0}if 2 div neg hei add ly add lhei sub/Y0 xdf}bdf\n\
/ET{}bdf\n\
\n\
scal\n\
landscape{/wid hei /hei wid def def /lx ly /ly lx def def}if\n\
" ;

main(argc,argv,envp)
	int	argc ;
	char	**argv ;
	char	**envp ;
	{
	register int	i ;
	register char	*p,*q ;
	int	fportrait = 0;
	int	debut, type, nbfic, j ;
	double	sc, sl, atof();

	if (GETWD(nom_dir) == (char *) NULL)
		strcpy(nom_dir,"./") ;
	else
		if(nom_dir[1]) strcat(nom_dir,"/") ;

	pa = ppa = (char **) malloc((argc+7) * sizeof(char *)) ;
	if (ppa == (char **) NULL) erreur(1) ;
	p = RINDEX(LPR, '/');
	*pa++ = p ? p+1 : LPR;
#ifdef LPROPT1
	if (sizeof LPROPT1 > 1) { *pa++ = LPROPT1 ; }
#endif
#ifdef LPROPT2
	if (sizeof LPROPT2 > 1) { *pa++ = LPROPT2 ; }
#endif
	nbfic = 0 ;
	ppf = pf = &ppa[argc+5] ;

	argc-- ;
	argv++ ;
	if((argc == 0) && isatty(0))
		erreur(0);	/* sans options -> msg usage */
	for(i=argc ; i-- ; argv++)
	    switch(**argv) {
	    case '-' :
		if(argv[1] == '\0') { /* stdin */
			*pf-- = (char *) 0;
			nbfic++ ;
			break;
		}
		p = *pa++ = *argv ;
		p++;
		if(*p == '?') erreur(0);
		if(p[1] &&((*p >= 'a') && (*p <= 'z'))) erreur(0);
		if(*p == 'J') jobopt++;
		if( (i>0) && (p[1] == '\0') &&	/* argument de lpr 1-4 et A-Z */
		    (((*p >= 'A') && (*p <= 'Z')) || /* sont suivis d'un nom, */
		     ((*p >= '1') && (*p <= '4')) ||
                     (*p == 'd')                  
						) ) {
			*pa++ = *++argv ; i--;
		}
		break ;
	    case '+' :	/* argument de pprps */
		p = *argv ;
		while (*(++p) != '\0')
		    switch(*p) {
		    case 'B' : binaire_ok = 1;
			break;
		    case '7' : ascii_7 = 1; opt_ascii_mac = 0;
			break;
		    case '8' : ascii_7 = 0; opt_ascii_mac = -1;
			break;
		    case 'I' : ascii_7 = 0; opt_ascii_mac = 0;
			break;
		    case 'M' : ascii_7 = 0; opt_ascii_mac = 1;
			break;
		    case 'l' : ffolding = 1;
		    case 'L' : flandscape = 1 ;
			if (fportrait) erreur(0) ;
			break ;
		    case 'p' : ffolding = 1;
		    case 'P' : fportrait = 1;
			if (flandscape) erreur(0) ;
			break ;
		    case 'n' : fentete = 1;
		    case 'N' : fnumero = 1;
			break ;
		    case 'h' : fentete = 1 ;
			break ;
		    case 'H' : fentete = 2 ;
			break ;
		    case 'D' : fdebug = 1 ;
			break ;
		    case 'o' : foutput = 1 ;
			break ;
		    case 'i' : 
			p++; if(*p == '\0') erreur(0);
			prologue = p;
			while(*p) p++; p-- ;
			break;
		    case 'V' :
			p++; q = vertspacing;
			while (*p >= '0' && *p <= '9') *q++ = *p++;
			if (*p == '.') {
				*q++ = *p++;
				while (*p >= '0' && *p <= '9') *q++ = *p++;
			}
			*q = '\0'; p--;
			break;
		    case 'X' :
			p++ ;
			nbcpage = 0 ;
			while((*p >= '0') && (*p <= '9'))
				nbcpage = nbcpage*10 + *p++ - '0' ;
			p-- ;
			break ;
		    case 'Y' :
			p++ ;
			nblpage = 0 ;
			while((*p >= '0') && (*p <= '9'))
				nblpage = nblpage*10 + *p++ - '0' ;
			p-- ;
			break ;
		    case 'Z' :
			p++; q = pointsize;
			while (*p >= '0' && *p <= '9') *q++ = *p++;
			if (*p == '.') {
				*q++ = *p++;
				while (*p >= '0' && *p <= '9') *q++ = *p++;
			}
			*q = '\0'; p--;
			break;
		    case 'z' : fpsize = 1 ;
			break ;
		    default : ppr_err = *p;
			erreur(3) ;
		    }
		    break ;
	    default :	/* fichier a imprimer */
		if(jobname==NULL)
			jobname = (p=RINDEX(*argv,'/'))?p+1:*argv;
		*pf-- = nom_abs(*argv); nbfic++ ;
		break ;
	    }

	if(jobname && !jobopt ) { *pa++ = JOB_OPTION; *pa++ = jobname; }
	*pa = (char *) NULL ;
	*pf = (char *) NULL ;
	if (flandscape) { i = 132 ; j = 55 ; p = "9"; }
	else { i = 80 ; j = 66 ; p = "10"; }
	if (pointsize[0] == '\0') { sc = 1.; strcpy(pointsize, p); }
	else sc =  atof(pointsize)/atof(p);
	if (vertspacing[0] == '\0') { sl = sc; strcpy(vertspacing, "1.1"); }
	else sl = sc * atof(vertspacing)/1.1;
	if((sc <= 0.) || (sl <= 0.)) erreur(7);
	if(nbcpage == 0) { if(sc != 1.) i = i/sc+0.5; nbcpage = i ; }
	if(nblpage == 0) { if(sl != 1.) j = j/sl+0.5; nblpage = j ; }
	if((nbcpage <= 0) || (nblpage <= 0)) erreur(7);

	if (fdebug) {
		fprintf(stderr,"arguments de lpr :\n") ;
		pa = ppa ;
		while (*pa) fprintf(stderr,"%s\n",*pa++) ;
		fprintf(stderr,"fichiers a imprimer :\n") ;
		pf = ppf ;
		while (nbfic--) fprintf(stderr,"%s\n",*pf--) ;
		exit(0) ;
	}
/*
 * Creation du processus executant lpr
 */
	if (!foutput) {
	    if (pipe(fd_lpr) == -1)
		erreur(5) ;
	    switch(fork())	{
	    case 0 :		/* processus fils ==> lpr */
		dup2(fd_lpr[0],0) ;
		close(fd_lpr[0]) ;
		close(fd_lpr[1]) ;
		execve(LPR,ppa,envp) ;
		erreur(4) ;
	    case -1 :		/* fork() impossible */
		erreur(6) ;
	    default :		/* processus pere */
		close(fd_lpr[0]) ;
		break ;
	    }
	    dup2(fd_lpr[1],1) ;
	    close(fd_lpr[1]) ;
	}
/*
 * Appel de la procedure de traitement des fichiers en entree.
 */
	debut = 1;
	pf = ppf ; i = nbfic;
	do {
		type = myfopen(*pf);	/* ouvrir fin */
		if(type < 0) {
		    fprintf(stderr,"can't open %s\n",*pf--) ; continue ; }
		if((type == TYPE_VIDE) && (nbfic == 0))
		    goto nxt; /* filtre et stdin vide: ne pas imprimer */
		if((type == TYPE_BINAIRE) && !binaire_ok) {
		    fprintf(stderr,
			"binary file %s (use +B to force printing)\n",*pf--) ;
		    goto nxt; }
		ascii_mac = opt_ascii_mac ;
		if(ascii_mac < 0) ascii_mac = (type==TYPE_MAC);

		if (debut) { debut = 0 ; out_prologue(); }
		decomp(*pf) ;
		automate();
		dedecomp() ;
nxt:
		fclose(fin);
		pf--;
	} while (--i > 0) ;

	if (!debut)
	    printf("%%%%Trailer\nET\n%%%%Pages: %d\n%%%%EOF\n", docpage);
	fclose(stdout) ;
	wait(0) ;		/* pour attendre la fin de lpr */
	exit(0) ;
	/*NOTREACHED*/
}

/*
 * Procedure d'affichage des erreurs du programme
 */
erreur(e)
	int	e ;	/* numero de message d'erreur a emettre */
	{
	if((e==2)||(e==3)) fprintf(stderr,"%s\n",msg_err[0]) ;
	fprintf(stderr,"%s\n",msg_err[e]) ;
	exit(1) ;
	}

/*
 * Procedure de calcul du nom absolu d'un fichier
 */
char *
nom_abs(n_fic)
	char	*n_fic ;	/* nom du fichier a convertir */
	{
	register char	*buf, *p, *p_fic ;
	int lg ;

	lg = strlen(n_fic)+1;
	if (*n_fic != '/') lg += strlen(nom_dir);
	if ((buf = malloc(lg)) == (char *) NULL) erreur(1) ;
	if (*n_fic == '/')
		strcpy(buf, n_fic) ;
	else {
		p_fic = nom_dir ; p = buf ; 
		while( *p_fic ) *p++ = *p_fic++;
		p--;
		for(;;) {
			if (strncmp(n_fic,"./", 2) == 0) {
				n_fic +=2; continue;
			}
			if (strncmp(n_fic,"../", 3) != 0) break;
			if(p == buf) break;
			p--;
			while((p != buf) && (*p != '/')) p--;
			if(*p == '.') { p-- ; break; }
			n_fic += 3;
		}
		p[1] = '\0';
		strcat(buf,n_fic) ;
	}
	return(buf) ;
}

/*
 * impression du prologue Postcript
 */
out_prologue()
{
	register char	*plogin ;
	register int c;
	FILE *fpr;

#ifdef	USG
	if ((plogin = cuserid((char *) 0)) == (char *) 0)
#endif	/*USG*/
	if ((plogin = getlogin()) == (char *) 0) {
		struct passwd *ppass = getpwuid((int)getuid());
		if (ppass == (struct passwd *) 0)
			plogin = "nobody";
		else
			plogin = ppass->pw_name;
	}
	mkdate(time((long *) 0)) ;
	printf("%%!PS-Adobe-2.0\n");
	printf("%%%%DocumentFonts: Courrier\n");
	printf("%%%%Creator: %s\n", PROGNAME);
	printf("%%%%CreationDate: %s\n", pdate);
	printf("%%%%For: %s\n", plogin);
	printf("%%%%Pages: (atend)\n");
	printf("%%%%BoundingBox: ? ? ? ?\n");
	printf("%%%%EndComments\n");
	printf("/sca %s def\n", pointsize);
	printf("/row %d def\n", nblpage) ;
	printf("/col %d def\n", nbcpage + (fnumero ? 8 : 0)) ;
	printf("/vsp %s def\n", vertspacing);
	printf("/landscape %s def\n", flandscape? "true" : "false");

	if(prologue) {
		if ((fpr = fopen(prologue,"r")) == (FILE *) 0) {
			fprintf(stderr,"can't open %s\n",prologue) ;
			exit(1) ; }
		while((c = getc(fpr))!= EOF) putchar(c);
		fclose(fpr);
	} else
		printf("%s", prologue_ps);

	if (fpsize) printf("DS\n");
	if(ascii_mac) printf("FM\n");
	printf("ST\n%%%%EndProlog\n");
}

/*
 * Procedure de traitement des fichiers.
 */
automate()
{
	register int	lg ;
	register unsigned c ;	/* caractere courant */
	register int	nbsp ;	/* nb car espaces non encore imprimes */
	register char	*ischar ; /* presence d'un caractere non termine */
	char	*nextischar ;
	char	ispage ;	/* presence d'une page non terminee */
	int	pcol ;	/* colonne sur l'imprimante */
	int	vcol ;	/* colonne sur le fichier */
	int	noligne ;/* numero de ligne du fichier */
	int	nbligne ;/* numero de ligne dans la page */
	int	nbcbs ;	/* nb car normaux dans la ligne */
	int	stligne; /* 1 bl; <=0: pas de bl; -1: lig suite; -2: apres \f */
	int	half;	/* 0, ou 1 si 1/2 interligne */
	static	char *lch[] = {" bl", ".5 bl"};
	unsigned char	buf[8], *p, cc;	/* pour sequence non imprimable */

	noligne = 1 ; nopage =  0 ;
	half = nbsp = stligne = nbcbs = vcol = pcol = 0 ;
	ischar = (char *) 0 ;
	nbligne = entete(); ispage = 1;
	for(;;){
	    switch(c = mygetc()) {
	    case '\f':
		if( !ispage ){ half= 0; nbligne= entete(); ispage= 1; }
	    case EOF :
		if(stligne > 0) {
			if(ischar){ printf(")%s",ischar);ischar=(char *)0;}
			putchar('\n'); }
		if(ispage) printf("EP\n") ;
		nbsp = nbcbs = vcol = pcol = ispage = nbligne = 0 ;
		stligne = -2;
		if( c == EOF ) return;
		break ;

	    case 013:		/* Reverse LF */
rlf:		if (stligne > 0) {	
			if(ischar){ printf(")%s",ischar);ischar=(char *)0;}
			putchar('\n');
		}
		if (nbligne > topligne) nbligne-- ;
		else half = 0;
		nbsp = stligne = nbcbs = vcol = pcol = 0 ;
		break ;

	    case 033:
		c = mypeekc();
		if((c<'7')||(c>'9')) {c = 033; goto cardef; }
		c = mygetc();
		if(c == '7') goto rlf; 	/* 7: reverse full line feed */
		half = 1 - half;
		if(c == '8')		/* 8: reverse half line feed */
			if(half==0) break; else goto rlf; 
		else			/* 9: forward half line feed */
			if(half==0) goto nl; else break;

	    case '\r':
		if( !ascii_mac ) goto cardef;
		/* else: en mac considerer rc comme nl */
	    case '\n':
nl:		if (stligne == -2) { /* \f \n: ignorer le \n */
			noligne++ ; stligne = 0; break; }
		if (stligne > 0) {	
			if(ischar){ printf(")%s",ischar);ischar=(char *)0;}
			putchar('\n');
		} else {	/* ouvrir la ligne */
			if (nbligne >= nblpage) {
				printf("EP\n") ; ispage = 0; }
			if( !ispage ) { half= 0; nbligne= entete(); ispage= 1; }
			if(fnumero && (stligne==0))
			  printf("%d%s(%7d)%s\n",nbligne,lch[half],noligne,fcn);
		}
		noligne++ ; nbligne++ ;
		nbsp = stligne = nbcbs = vcol = pcol = 0 ;
		break ;

	    case '\t' : lg = 8 - vcol%8 ;
		goto comtab;
	    case ' ' :
		goto comnorm;
	    case 0312 : if(!ascii_mac) goto cardef;
		c = ' ';	/* espace insecable */
		goto comnorm;
	    case 0240 : if(ascii_mac) goto cardef;
		c = ' ';	/* espace insecable */
		goto comnorm;

	    case 0360:
		if( !ascii_mac ) goto cardef;
		/* en code mac, il faut utiliser la fonction ap */
		nextischar = (char *) 0;
		goto comnorm;
	    case 0255: case 0260: case 0262: case 0263:
	    case 0266: case 0267: case 0270: case 0271:
	    case 0272: case 0275: case 0303: case 0305:
	    case 0306: case 0327:
		if( !ascii_mac ) goto cardef;
		/* en code mac, utiliser la fonte Symbol pas de bold */
		nextischar = (typfont == 2) ? fcs[1] : fcs[0];
		goto comnorm;

	    case '\b':
		if(nbcbs <= 0) goto cardef; /*considerer comme non imprimable*/
		if(nbsp == 0) {
			if(ischar){ printf(")%s", ischar); ischar = (char *)0; }
			printf(" ta"); /* ispage = 1 ; vrai */
		} else nbsp-- ;
		pcol-- ; vcol-- ; nbcbs-- ;
		break ;

	    default:
cardef:		nextischar = typfont ? fcb[typfont-1] : fcn;
		if( !estimprimable(c) ) {
			p = buf; cc = c;
			if(cc>=0200) { cc -= 0200; *p++ ='M'; *p++ = '-'; }
			if((cc<' ')||(cc==0177)) { cc ^= 0100; *p++ ='^'; }
			if(cc=='\\') *p++ = cc; *p++ = cc; *p = 0;
			lg = p-buf;
			goto comtab;
		}
comnorm:	lg = 1;
comtab:		if (ffolding && (pcol+lg > nbcpage)) {
		    if(stligne>0) {
			if(ischar){ printf(")%s",ischar);ischar=(char *)0;}
			putchar('\n'); }
		    nbligne++ ;
		    if(c == '\t') lg -= nbcpage-pcol;
		    nbsp = nbcbs = pcol = 0; stligne = -1;
		}
		if (nbligne >= nblpage) { /* apres \n \f ou fold: stline<= 0 */
			printf("EP\n") ; ispage = 0; }
		if( !ispage ) { half= 0; nbligne= entete(); ispage= 1; }
		if(stligne <= 0) {
		    if(stligne == -2) stligne = 0;	/* oublier \f */
		    if(fnumero) {
			if(stligne == 0) {
				printf("%d%s(%7d",nbligne,lch[half],noligne);
				ischar = fcn ; nbsp++ ; stligne = 1;
			} else nbsp += 8;
		    }
		}
		if((c==' ')||(c=='\t')) { nbsp += lg; goto nextcar; }

	/* il faut imprimer, en traitant d'abord nbsp en attente */
		if(stligne<=0){ printf("%d%s",nbligne,lch[half]); stligne=1;}
		if(nbsp && (ischar == fcn) && (nbsp < 8))
			if((nbsp < 5) || (nextischar == fcn))
				for(; nbsp>0; nbsp--) putchar(' ');
		if(nbsp && ((nbsp >= 5) || (nextischar != fcn))) {
			if(ischar){ printf(")%s", ischar); ischar = (char *)0; }
			printf(" %d S", nbsp); nbsp = 0;
		}
		if(ischar != nextischar) {
			if(ischar) printf(")%s", ischar);
			if(nextischar) putchar('(');
			ischar = nextischar; }
		for(; nbsp>0; nbsp--) putchar(' ');

	/* imprimer le car en attente */
		switch(c) {
		case 0360: if(!ascii_mac) goto impcar;
			printf(" %s", ap[typfont]);
			break;
		case '\\': case '(': case ')':
			putchar('\\') ;
			goto impcar;
		default:
impcar:		    if(lg == 1) {/* car imprimable */
#ifndef USE8BITS
			if(c >= 0200) printf("\\%03o", c) ;
			else
#endif
				putchar(c) ;
		    } else {	/* car non imprimable */
			printf("%s", buf) ;
			nbcbs = -lg ; /* remettre nbcs a 0 */
		    }
		    break;
		}
nextcar:	nbcbs += lg ; pcol += lg ; vcol += lg ;
		break ;
	} }	/* fin switch, fin for */
}

/*
 *	entete() ecrit l'entete de page, et retourne le numero de ligne courant.
 */
entete()
{
	register char	**pp, *p ;
	register int	i, j ;

	printf("%%%%Page: ? %d\nBP\n", ++docpage);
	i = 0;
	if(fentete) {
		pp = &nom_fic[0] ;
		i= flandscape ? NBLANDSCAPE : 0 ;
		printf("%d bl(%-17s  ", i++, pdate) ;
#define FIXENTETE	(19+13+1)
		j = FIXENTETE - (fnumero ? 8 : 0) ;
		for( p = *pp++; *p; p++ ) {
#ifndef USE8BITS
			if(((unsigned char)*p)>=0200)
				printf("\\%03o", (unsigned char)*p);
			else
#endif
				putchar(*p) ;
			j++;
		}
		while(j++ < nbcpage) putchar(' ') ;
		printf("  Page : %4d)sI\n",++nopage) ;
		while(*pp != (char *) 0)
			printf("%d bl(%-17s  %s)sI\n",i++," ",*pp++) ;
		i += 2 ;
	}
	topligne = i;
	return i;
}

/*
 *	decomp() assure la decomposition pour folding du nom du fichier.
 */
decomp(fichier)
	char	*fichier ;
	{
	register char	*p, *q, *r, **pp;
	register unsigned i ;
	unsigned lg;
	int	fini ;
	long	date;
	struct	stat	buf;

	if(!fentete) return;
	if(fichier == (char *) 0) fichier = "";		/* stdin */

	if( (fstat(fileno(fin), &buf)<0) || ((date = buf.st_mtime) ==0))
		date = time((long *) 0) ;
	mkdate(date) ;

	lg = nbcpage - FIXENTETE;
	pp = &nom_fic[0] ;
	p = fichier ;
	if( fentete == 1 ) {
		i = strlen(p);
		*pp++ = q = malloc(i<lg ? i+1 : lg+sizeof(DO3POINTS)+1);
		if (q == (char *) 0) erreur(1);
		if (i > lg) {
			strcpy(q, DO3POINTS);
			q += strlen(q);
			r = p += i-lg+1;
			while( *r && (*r != '/')) r++;
			if(*r) p = r;
		} 
		strcpy(q, p);
	} else {
	    fini = 0;
	    do {
		i = lg;
		r = (char *) 0;
		for (q = p  ; (*q != '\0') && (i > 0) ; i--)
			if (*q++ == '/') r = q ;
		i = q - p ;
		if( *q == '\0') fini = 1;
		else if( r && (r-p > i-MAXTRUNC) )
			i = r - p ;
		if ((q = malloc(i+1)) == (char *) 0) erreur(1) ;
		*pp++ = q ;
		while (i-- > 0)
			*q++ = *p++ ;
		*q = '\0' ;
	    } while(!fini);
	}
	*pp = (char *) 0 ;
	return ;
}

/*
 *	dedecomp() detruit les malloc de decomp().
 */
dedecomp() {
	register char	**pp ;

	if(fentete) 
		for (pp = nom_fic ; *pp != (char *) 0 ;) free(*pp++) ;
}

int estimprimable(c)
register unsigned c;
{
	if(c < 0200) return ((c >= ' ') && (c != 0177));
	if(ascii_7) return 0;
	if(ascii_mac) return 1;
	return (c >= 0240);
}

/*
 * Ouvrir, positionner les buffers, tester le type de fichier <0: inexistant;
 */
int myfopen(nom)
char *nom;
{
	int bin, et, mac, nl, cr;
	register unsigned char *p;
	register int i;

	if(nom == NULL) fin = stdin;
	else fin = fopen(nom,"r");
	if(fin == NULL) return -1;
	nb = fread(pos= bufin, 1, BUFSIZ, fin);
	if(nb == 0)
		return TYPE_VIDE;
	bin = et = mac = nl = cr = 0;
	for(p = bufin, i = nb; i != 0; p++, i--) {
		if(*p < 040) {
			if(((*p < 010) || (*p >= 016)) && (*p != 033)) bin++;
			if(*p == '\n') nl++; if(*p == '\r') cr++; }
		else if(*p < 0200) { if(*p == 177)  bin++; }
		else { et++; if(*p <= 0240) mac++; }
	}
	if(bin*5 >= nb) return TYPE_BINAIRE;	/* >=20% binaire */
	if(300*(cr+nl) < nb) return TYPE_BINAIRE; /* pas assez de lignes */
	i = 5; if(et < 100) i = 2; if(et < 10) i = 0;
	if(mac>i) return TYPE_MAC;
	if(cr > 2*nl) return TYPE_MAC;	/* test du delimiteur de ligne */
	return TYPE_ISO;
}

/*
 * lire le caractere suivant. Tester les sequences nroff
 * reconnus : c\bc\bc\bc -> bold(1); _\bc -> souligne(2)
 */
int
mygetc()
{
	register unsigned c;
	register int i;
	register unsigned char *p, *q;

	typfont = 0;
	if(nb == 0)		/* eof */
		return EOF;
	c = *pos++; nb--;
	if(nb == 0) {
		nb= fread(pos= bufin, 1, BUFSIZ, fin);
		if(nb == 0) return c; }
	p = pos;
	if(*p != '\b') return c;
	if( nb < 6 ) {
		q = bufin; i = nb; while(i--) *q++ = *p++;
		nb+= fread(q, 1, BUFSIZ, fin);
		pos = p = bufin;
	}
	if( (nb >= 6) &&
	    (p[1]==c)&&(p[3]==c)&&(p[5]==c)&&(p[2]=='\b')&&(p[4]=='\b')) {
		nb -= 6; pos += 6; typfont = 1; }
	if( (nb >= 2) && (c=='_') ) {
		c = p[1]; nb -= 2; pos += 2; typfont = 2; }
	if(nb == 0) nb= fread(pos= bufin, 1,BUFSIZ,fin);
	return c;
}

mkdate(date)
long	date ;
{
	register char *p;
	char	pmois[4], pjour[3], pheure[6], pannee[5] ;

	p = ctime(&date) ; /* "JJJ MMM DD hh:mm:ss YYYY\n\0" */
	strncpy(pmois,&p[4],3) ; pmois[3] = '\0' ;
	strncpy(pjour,&p[8],2) ; pjour[2] = '\0' ;
	strncpy(pheure,&p[11],5) ; pheure[5] = '\0' ;
	strncpy(pannee,&p[20],4) ; pannee[4] = '\0' ;
	sprintf(pdate,"%s %s %s %s",pmois,pjour,pheure,pannee) ;
}
